using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Tools;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;

		public DataTable TextBoxSource = new DataTable();
		private Syncfusion.Windows.Forms.Tools.AutoComplete autoComplete1;
		private System.Windows.Forms.TextBox textBox1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			TextBoxSource.Columns.Add("valueField",typeof(int));
			TextBoxSource.Columns.Add("displayField",typeof(string));
			TextBoxSource.Columns.Add("otherData",typeof(string));
			
			this.AddTextBoxEntry("Fidelity");
			this.AddTextBoxEntry("Fiduciary");
			this.AddTextBoxEntry("Freddie Mac");
			this.AddTextBoxEntry("Fredrickson");
			this.AddTextBoxEntry("Froder's");
			this.AddTextBoxEntry("Teachers");
			this.AddTextBoxEntry("Tallwood");
			this.AddTextBoxEntry("Telecommunications");
			this.AddTextBoxEntry("Trader");
			this.AddTextBoxEntry("Terrible");

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		void AddTextBoxEntry(string customerName)
		{
			object [] DataRowArray = new object[3];
			DataRowArray.SetValue(TextBoxSource.Rows.Count,0);
			DataRowArray.SetValue(customerName,1);
			DataRowArray.SetValue("OtherInfo",2);
	
			TextBoxSource.Rows.Add(DataRowArray);
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.autoComplete1 = new Syncfusion.Windows.Forms.Tools.AutoComplete();
			this.textBox1 = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.autoComplete1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(24, 16);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(584, 216);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// autoComplete1
			// 
			this.autoComplete1.AccessibleDescription = null;
			this.autoComplete1.AccessibleName = null;
			this.autoComplete1.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.autoComplete1.AdjustHeightToItemCount = true;
			this.autoComplete1.AutoAddItem = false;
			this.autoComplete1.AutoSerialize = true;
			this.autoComplete1.CategoryName = "";
			this.autoComplete1.ParentForm = this;
			this.autoComplete1.PreferredHeight = 200;
			this.autoComplete1.SelectedIndex = -1;
			this.autoComplete1.SelectedValue = "";
			this.autoComplete1.ShowCloseButton = true;
			this.autoComplete1.ShowGripper = true;
			// 
			// textBox1
			// 
			this.autoComplete1.SetAutoComplete(this.textBox1, Syncfusion.Windows.Forms.Tools.AutoCompleteModes.AutoSuggest);
			this.textBox1.Location = new System.Drawing.Point(80, 320);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(160, 20);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 462);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.autoComplete1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DataTable getTable()
		{
			DataTable dt = new DataTable("com");
			dt.Columns.Add("ShowData");
			for(int i = 0 ;i< 5;i++)
			{
				dt.Rows.Add(new object[]{"ShowData" + i});   
			}
			return dt;
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			TextBoxAutoCompleteCellModel TextBoxAutoCompleteCellModel = new WindowsApplication1.TextBoxAutoCompleteCellModel(this.gridControl1.Model);
			TextBoxAutoCompleteCellModel.autoComplete1.ParentForm = this;

			this.gridControl1.CellModels.Add("TextBoxAutocomplete", TextBoxAutoCompleteCellModel);
			this.gridControl1.ColStyles[1].CellType = "TextBoxAutocomplete";
			TextBoxAutoCompleteCellRenderer cr = (TextBoxAutoCompleteCellRenderer)this.gridControl1.CellRenderers["TextBoxAutocomplete"]  ;

			AutoCompleteDataColumnInfo info = new AutoCompleteDataColumnInfo("displayField",200,true);
			this.gridControl1.ColStyles[1].BackColor = Color.AliceBlue; 
			this.gridControl1[0,1].Text = "AutoCompleteWithoutDataSource";

			this.gridControl1[0,2].Text = "AutoCompleteWithDataSource";
			this.gridControl1.ColStyles[2].CellType = "TextBoxAutocomplete";
			this.gridControl1.ColStyles[2].BackColor = Color.Red;
						
			info = new AutoCompleteDataColumnInfo("ShowData",200,true);
			this.gridControl1.ColStyles[2].DataSource = this.getTable();
			this.gridControl1.ColStyles[2].Tag = info;

			this.gridControl1.ColWidths.ResizeToFit(GridRangeInfo.Cols(1,2)); 
   
			this.autoComplete1.SetAutoComplete(this.textBox1,AutoCompleteModes.AutoSuggest);
			this.autoComplete1.DataSource = this.TextBoxSource;  
		}
	}
}
